package com.shadeslider.utils 
{
    import flash.display.*;
    import flash.events.*;
    import flash.utils.*;
    
    public class VisualEffects extends Object
    {
        public function VisualEffects()
        {
            super();
            return;
        }

        public static function fadeIn(arg1:flash.display.DisplayObject, arg2:Number=0, arg3:Object=null):void
        {
            var cTimer:flash.utils.Timer;
            var cTimerRepeatCount:Number;
            var options:Object;
            var pObject:flash.display.DisplayObject;
            var pOptions:Object=null;
            var pSpeed:Number=0;

            var loc1:*;
            cTimerRepeatCount = NaN;
            cTimer = null;
            pObject = arg1;
            pSpeed = arg2;
            pOptions = arg3;
            if (fadeInCurrentDO == pObject)
            {
                return;
            }
            options = {"speed":100, "show":true};
            options.speed = pSpeed;
            com.shadeslider.utils.ObjectUtils.overrideProperties(options, pOptions);
            cTimerRepeatCount = Math.ceil(options.speed / (1000 / 30));
            cTimer = new flash.utils.Timer(1000 / 40, cTimerRepeatCount);
            cTimer.addEventListener(flash.events.TimerEvent.TIMER, function (arg1:flash.events.TimerEvent):void
            {
                pObject.alpha = cTimer.currentCount / cTimerRepeatCount;
                return;
            })
            cTimer.addEventListener(flash.events.TimerEvent.TIMER_COMPLETE, function (arg1:flash.events.TimerEvent):void
            {
                fadeInCurrentDO = null;
                return;
            })
            if (options.show)
            {
                pObject.visible = true;
                pObject.alpha = 0;
            }
            fadeInCurrentDO = pObject;
            cTimer.start();
            return;
        }

        public static function fadeOut(arg1:flash.display.DisplayObject, arg2:Number=0, arg3:Object=null):void
        {
            var cTimer:flash.utils.Timer;
            var cTimerRepeatCount:Number;
            var options:Object;
            var pObject:flash.display.DisplayObject;
            var pOptions:Object=null;
            var pSpeed:Number=0;

            var loc1:*;
            options = null;
            cTimerRepeatCount = NaN;
            cTimer = null;
            pObject = arg1;
            pSpeed = arg2;
            pOptions = arg3;
            if (fadeOutCurrentDO == pObject)
            {
                return;
            }
            options = {"speed":100, "hide":true};
            options.speed = pSpeed;
            com.shadeslider.utils.ObjectUtils.overrideProperties(options, pOptions);
            cTimerRepeatCount = Math.ceil(options.speed / (1000 / 30));
            cTimer = new flash.utils.Timer(1000 / 40, cTimerRepeatCount);
            cTimer.addEventListener(flash.events.TimerEvent.TIMER, function (arg1:flash.events.TimerEvent):void
            {
                pObject.alpha = 1 - cTimer.currentCount / cTimerRepeatCount;
                return;
            })
            cTimer.addEventListener(flash.events.TimerEvent.TIMER_COMPLETE, function (arg1:flash.events.TimerEvent):void
            {
                if (options.hide)
                {
                    pObject.visible = false;
                }
                fadeOutCurrentDO = null;
                return;
            })
            fadeOutCurrentDO = pObject;
            pObject.visible = true;
            cTimer.start();
            return;
        }

        private static var fadeOutCurrentDO:flash.display.DisplayObject;

        private static var fadeInCurrentDO:flash.display.DisplayObject;
    }
}
