package com.shadeslider.project.controllers 
{
    import com.shadeslider.base.*;
    import com.shadeslider.project.events.*;
    import flash.external.*;
    import flash.net.*;
    import flash.system.*;
    
    public class ToolbarController extends com.shadeslider.base.AbstractController
    {
        public function ToolbarController(arg1:com.shadeslider.base.AbstractModel, arg2:com.shadeslider.base.ComponentView, arg3:Object, arg4:com.shadeslider.project.controllers.MainController=null, arg5:Object=null)
        {
            super(arg1, arg2, arg3, arg4);
            return;
        }

        private function onViewChooseCityHandler(arg1:com.shadeslider.project.events.ToolbarViewEvent):void
        {
            model.APP_STATE = com.shadeslider.project.events.ApplicationStates.INIT_MODAL;
            model.currentCityCode = arg1.data.code;
            model.APP_STATE = com.shadeslider.project.events.ApplicationStates.INIT_ITEMS_RELOAD;
            return;
        }

        private function onViewBlogCodeHandler(arg1:com.shadeslider.project.events.ToolbarViewEvent):void
        {
            flash.system.System.setClipboard(model.blogCodeHTML);
            return;
        }

        private function onViewCollapseHandler(arg1:com.shadeslider.project.events.ToolbarViewEvent):void
        {
            flash.external.ExternalInterface.call("eclipseWidgetCollapse");
            return;
        }

        protected override function addViewEventListeners():void
        {
            view.addEventListener(com.shadeslider.project.events.ToolbarViewEvent.BLOG_CODE, this.onViewBlogCodeHandler);
            view.addEventListener(com.shadeslider.project.events.ToolbarViewEvent.HOT_STUFF, this.onViewHotStuffHandler);
            view.addEventListener(com.shadeslider.project.events.ToolbarViewEvent.CHOOSE_CITY, this.onViewChooseCityHandler);
            view.addEventListener(com.shadeslider.project.events.ToolbarViewEvent.EXPAND, this.onViewExpandHandler);
            view.addEventListener(com.shadeslider.project.events.ToolbarViewEvent.COLLAPSE, this.onViewCollapseHandler);
            return;
        }

        private function onViewExpandHandler(arg1:com.shadeslider.project.events.ToolbarViewEvent):void
        {
            return;
        }

        private function onViewHotStuffHandler(arg1:com.shadeslider.project.events.ToolbarViewEvent):void
        {
            flash.net.navigateToURL(new flash.net.URLRequest("http://eclipse.afisha.ru?cityCode=" + model.currentCityCode), "_blank");
            return;
        }
    }
}
